//
// Verilog description for cell counter, 
// Mon Mar 30 12:50:24 2009
//
// LeonardoSpectrum Level 3, 2005a.82 
//


module counter ( CLK, RST, qsig ) ;

    input CLK ;
    input RST ;
    output [2:0]qsig ;

    wire qanotsig, qbnotsig, nx20;
    wire [0:0] \$dummy ;




    dff dffA (.CLK (CLK), .RST (RST), .D (nx20), .Q (qsig[0]), .Qnot (qanotsig)
        ) ;
    dff dffb (.CLK (qanotsig), .RST (RST), .D (nx20), .Q (qsig[1]), .Qnot (
        qbnotsig)) ;
    dff_unfolded0 dffc (.CLK (qbnotsig), .RST (RST), .D (nx20), .Q (qsig[2]), .Qnot (
                  \$dummy [0])) ;
    assign nx20 = 0 ;
endmodule


module dff_unfolded0 ( CLK, RST, D, Q, Qnot ) ;

    input CLK ;
    input RST ;
    input D ;
    output Q ;
    output Qnot ;

    wire Qnot_rename, NOT_D;



    assign Qnot = 0 ;
    assign NOT_D = ~Qnot_rename ;
    DFFRS reg_Qnot (.set (RST), .reset (Qnot), .in (NOT_D), .clk (CLK), .out (
          Qnot_rename)) ;
    DFFRS reg_Q (.set (Qnot), .reset (RST), .in (Qnot_rename), .clk (CLK), .out (
          Q)) ;
endmodule


module dff ( CLK, RST, D, Q, Qnot ) ;

    input CLK ;
    input RST ;
    input D ;
    output Q ;
    output Qnot ;

    wire GND0, NOT_D;



    assign GND0 = 0 ;
    assign NOT_D = ~Qnot ;
    DFFRS reg_Qnot (.set (RST), .reset (GND0), .in (NOT_D), .clk (CLK), .out (
          Qnot)) ;
    DFFRS reg_Q (.set (GND0), .reset (RST), .in (Qnot), .clk (CLK), .out (Q)) ;
endmodule


module DFFRS ( set, reset, in, clk, out ) ;

    input set ;
    input reset ;
    input in ;
    input clk ;
    output out ;
reg out; 
always @ (posedge set or posedge reset or posedge clk)
begin
    if (set) out = 1;
    else if (reset) out = 0;
    else begin
     out = in;
    end
end

endmodule

