
#include "powerclass.h"


float circuit::getcjunc(int gateid){

int stim[0];
int k;
float cap=0;

if(gtype[gateid] == NAND){
Mn=1;Mp=fanin[gateid];
}else if(gtype[gateid] == NOR){
Mn=fanin[gateid];Mp=1;
}else if(gtype[gateid] == XNOR || gtype[gateid] == BUFF){                  /* buffer out connected to invertor of double standard invertor size*/
Mn=2;Mp=2;
}else{
Mn=1;Mp=1;
}

k=faninlist[gateid][0];                             /*taking anyone fanin pins ..not accurate*/

if(gtype[k] == QBAR)                                /* for QB node , take Q node */
	k=k-1;

cap = readcapfile(gateid,k,":cdtot");

 if(cap == 0){
		getcellsize(gateid);
		stim[0]=gold[k];
		runscript(gateid,stim,1,"x");
		cap = readcapfile(gateid,k,":cdtot");
}

//printf("test cap %f \n",cap/1e-15);

return cap;
}

float circuit::getcload(int gateid){
	int stim[0];
	int i,k;
	float totcload=0,cload=0;

	for (i=0;i<fanout[gateid];i++){
		k=fanoutlist[gateid][i];

        if(gtype[k] == OUTPUT){

		 cload = 3.2e-15;                               /* average invertor capacitance for output port load */

	    }else{
        	cload = readcapfile(k,gateid,":capin=");

        	if(cload == 0){
			getcellsize(k);
			stim[0]=gold[gateid];

			runscript(k,stim,1,"x");
			cload = readcapfile(k,gateid,":capin=");

			}
		}
		//printf("test cload %f \n",cload/1e-15);
		totcload=totcload + cload;
	}


	totcload = totcload + getcjunc(gateid);

	return totcload;
}


float circuit::readcapfile(int gateid,int gid,char *search){
FILE *infile2;
char fname[40],str[20];
float cap1=0,cap2=0;
sprintf(str, "%d",gtype[gateid]);
strcpy(fname,"models/cap/");
strcat(fname,str);
strcat(fname,"_0");
sprintf(str, "%d",fanin[gateid]);
strcat(fname,str);
strcat(fname,".cap");
infile2=fopen(fname,"r");

 if(zerodelay == 1 && gzero[gid] != 2){                  /**** check done as error may occur during logic power calculaton , gzero maybe X for a fanin way below the netlist ****/
 sprintf(str,"%d",gzero[gid]);
 }else{
 sprintf(str,"%d",gold[gid]);
 }

 strcat(str,search);

if(infile2 == NULL){
return 0;                                /* if cap file doesnt exist create new */
}else{
	   while(!feof(infile2)){
		   fscanf(infile2,"%s",&fname);
			if(!strcmp(fname,str)){
				if(!strcmp(search,":capin=")){
				fscanf(infile2,"%f",&cap1);
				fclose(infile2);
				return cap1;
				}
				fscanf(infile2,"%f",&cap1);
				fscanf(infile2,"%f",&cap2);
				fclose(infile2);
				return Mn*cap1 + Mp*cap2;
			}

		}
}

fclose(infile2);
return 0;                                /* if a particular entry doesnt exist runscript */
}


float circuit::readcaplist(char *cktname,int gateid){
	FILE *infile;
	char fname[40];
	int gid;
	float cap=0;

	strcpy(fname,cktname);
	strcat(fname, ".cap");
	infile=fopen(fname,"r");
	if(infile == NULL){
	printf(" cap file cannot be found\n");
	exit(-1);
	}

    while(!feof(infile)){

	fscanf(infile,"%d",&fid);
	gid=fid;
	fscanf(infile,"%e",&cap);


	if(gid == gateid){
	fclose(infile);
	return cap;
	}

	}

}

