
#include "powerclass.h"

int circuit::evaluate(int gid){

           int i;
           int *faninvalues;
           int gnew1;

           faninvalues = new int[fanin[gid]];

           for(i=0;i<fanin[gid];i++){
			   faninvalues[i]=gold[faninlist[gid][i]];
		   }

		   if(gtype[gid] == AND)
			     gnew1=andop(faninvalues,fanin[gid]);
		   else if(gtype[gid] == OR) {
		           gnew1=orop(faninvalues,fanin[gid]);
		   }else if(gtype[gid] == XOR || gtype[gid] == XOR_2X){
			      gnew1=xorop(faninvalues,fanin[gid]);
		   }else if(gtype[gid] == XNOR || gtype[gid] == XNOR_2X){
			      gnew1=xnorop(faninvalues,fanin[gid]);
		   }else if(gtype[gid] == NAND || gtype[gid] == NAND_2X) {
			      gnew1=nandop(faninvalues,fanin[gid]);
		   }else if(gtype[gid] == OAI21 || gtype[gid] == OAI22 || gtype[gid] == OAI221 || gtype[gid] == OAI222 || gtype[gid] == OAI32 || gtype[gid] == OAI321 || gtype[gid] == OAI322 || gtype[gid] == OAI33 || gtype[gid] == OAI43 || gtype[gid] == OAI332 || gtype[gid] == OAI44) {
			      gnew1=oaiop(faninvalues,gid);
		   }else if(gtype[gid] == AOI21 || gtype[gid] == AOI22 || gtype[gid] == AOI221 || gtype[gid] == AOI222 || gtype[gid] == AOI32 || gtype[gid] == AOI321 || gtype[gid] == AOI322 || gtype[gid] == AOI33 || gtype[gid] == AOI43) {
			      gnew1=aoiop(faninvalues,gid);
		   }else if(gtype[gid] == AO21 || gtype[gid] == AO21 || gtype[gid] == AO22 || gtype[gid] == AO221 || gtype[gid] == AO32) {
			      gnew1=aoop(faninvalues,gid);
		   }else if(gtype[gid] == MUX || gtype[gid] == MUX_NI) {
			      gnew1=muxop(faninvalues,gid);
	       }else if(gtype[gid] == INV || gtype[gid] == INV_2X || gtype[gid] == INV_4X || gtype[gid] == INV_8X || gtype[gid] == INV_12X || gtype[gid] == INV_16X) {
			      gnew1=notop(faninvalues[0]);
		   }else if(gtype[gid] == NOR || gtype[gid] == NOR_2X){
			      gnew1=norop(faninvalues,fanin[gid]);
	       }else if(gtype[gid] == NOR_ii){
			      gnew1=norii_op(faninvalues,fanin[gid]);
		   }else if(gtype[gid] == BUFF || gtype[gid] == BUFF_2X || gtype[gid] == BUFF_4X || gtype[gid] == BUFF_8X || gtype[gid] == BUFF_12X){
			      gnew1=faninvalues[0];
		   //}else if(gtype[gid] == QBAR) {
			     // gnew1=gnew[gid];
		   }else if(gtype[gid] == DFF || gtype[gid] == DFFR){
			      gnew1=dffop(faninvalues,gid);
		   }else if(gtype[gid] == LATCH || gtype[gid] == LATCHR || gtype[gid] == LATCHS || gtype[gid] == LATCHS_NI){
			      gnew1=latchop(faninvalues,gid);
		   }else{
			 printf("Gate type not understood %d\n",gid);
			exit(-1);
		 }

        return gnew1;


 }


float circuit::leakagepow(int gid){
           int i;
           int *faninvalues;
           float leakage;

           faninvalues = new int[fanin[gid]];

           for(i=0;i<fanin[gid];i++){
			   faninvalues[i]=gold[faninlist[gid][i]];
		   }


		   if(gtype[gid] == AND)
			     leakage=andleakage(faninvalues,gid);
		   else if(gtype[gid] == OR) {
		          leakage=orleakage(faninvalues,gid);
		   }else if(gtype[gid] == NAND || gtype[gid] == NAND_2X) {
			      leakage=nandleakage(faninvalues,gid);
		   }else if(gtype[gid] == INV || gtype[gid] == INV_2X || gtype[gid] == INV_4X || gtype[gid] == INV_8X || gtype[gid] == INV_12X || gtype[gid] == INV_16X) {
			      leakage=notleakage(faninvalues,gid);
		   }else if(gtype[gid] == NOR || gtype[gid] == NOR_2X){
			      leakage=norleakage(faninvalues,gid);
		   }else if(gtype[gid] == NOR_ii){
			      faninvalues[1]=notop(faninvalues[1]);
			      leakage=norleakage(faninvalues,gid);
		   }else if(gtype[gid] == OAI21 || gtype[gid] == OAI22 || gtype[gid] == OAI221 || gtype[gid] == OAI222 || gtype[gid] == OAI32 || gtype[gid] == OAI321 || gtype[gid] == OAI322 || gtype[gid] == OAI33 || gtype[gid] == OAI43 || gtype[gid] == OAI332 || gtype[gid] == OAI44) {
			      leakage=oaileakage(faninvalues,gid);
		   }else if(gtype[gid] == AO21 || gtype[gid] == AO21 || gtype[gid] == AO22 || gtype[gid] == AO221 || gtype[gid] == AO32) {
                  leakage=aoleakage(faninvalues,gid);
		   }else if(gtype[gid] == AOI21 || gtype[gid] == AOI22 || gtype[gid] == AOI221 || gtype[gid] == AOI222 || gtype[gid] == AOI32 || gtype[gid] == AOI321 || gtype[gid] == AOI322 || gtype[gid] == AOI33 || gtype[gid] == AOI43) {
			   	  leakage=aoileakage(faninvalues,gid);
		   }else if(gtype[gid] == MUX || gtype[gid] == MUX_NI) {
			      muxleakage(faninvalues,gid);
		   }else if(gtype[gid] == DFF) {
			      //leakage=dffleakage(faninvalues,gid);
		   }else if(gtype[gid] == DFFR) {
			      //leakage=dffrleakage(faninvalues,gid);
		   }else if(gtype[gid] == LATCH || gtype[gid] == LATCHR || gtype[gid] == LATCHS || gtype[gid] == LATCHS_NI){
			      leakage=latchleakage(faninvalues,gid);
		   }else if(gtype[gid] == BUFF || gtype[gid] == BUFF_2X || gtype[gid] == BUFF_4X || gtype[gid] == BUFF_8X || gtype[gid] == BUFF_12X){
			      leakage=buffleakage(gid);
		   }else if(gtype[gid] == XOR || gtype[gid] == XOR_2X){
                   leakage=xorleakage(faninvalues,gid);
		   }else if(gtype[gid] == XNOR || gtype[gid] == XNOR_2X){
			       leakage=xnorleakage(faninvalues,gid);
		   }else{
			 printf("Gate type not understood (leakage) %d\n",gid);
			exit(-1);
		 }


        return leakage ;

 }
