#include "powerclass.h"

/*****AND****/
int circuit::andop(int fvalues[],int count){
    int i;
    i=nandop(fvalues,count);
    return notop(i);
}

/*****NAND****/
int circuit::nandop(int fvalues[],int count){
	int i,xcount=0;
	for(i=0; i < count; i++){
		if(fvalues[i] == 0){
			return 1;
		}else if(fvalues[i] == 2){
			xcount++;
		}
	}
	if(xcount > 0)
	return 2;
	else
	return 0;

}

/*****MUX21 and MUX21_NI****/
int circuit::muxop(int fvalues[],int gateid){
	int i;

	if(fvalues[2] == 0)
	   i = fvalues[0];
	else if(fvalues[2] == 1)
	   i = fvalues[1];
	else
	   i = 2;


	if(gtype[gateid] == MUX)
	return notop(i);
	else
	return i;

}

/*****OAI****/
int circuit::oaiop(int fvalues[],int gateid){
	int *i;
	int value;

	if (gtype[gateid] == OAI21){
		i = new int[2];
        i[0] = orop(fvalues,2);
        i[1] = fvalues[2];

        value = nandop(i,2);

    }else if(gtype[gateid] == OAI22){
		i = new int[2];
		i[0] = fvalues[2];
		i[1] = fvalues[3];
		i[0] = orop(i,2);
		i[1] = orop(fvalues,2);

		value = nandop(i,2);

	}else if(gtype[gateid] == OAI221){
		i = new int[3];
		i[0] = fvalues[2];
		i[1] = fvalues[3];
		i[0] = orop(i,2);
		i[1] = orop(fvalues,2);
		i[2] = fvalues[4];

		value = nandop(i,3);
	}else if(gtype[gateid] == OAI222){
		i = new int[3];
		i[0] = fvalues[4];
		i[1] = fvalues[5];
		i[2] = orop(i,2);
		i[0] = fvalues[2];
		i[1] = fvalues[3];
		i[1] = orop(i,2);
		i[0] = orop(fvalues,2);

		value = nandop(i,3);
	}else if(gtype[gateid] == OAI32){
		i = new int[2];
		i[0] = fvalues[3];
		i[1] = fvalues[4];
		i[1] = orop(i,2);
		i[0] = orop(fvalues,3);

		value = nandop(i,2);
	}else if(gtype[gateid] == OAI321){
		i = new int[3];
		i[0] = fvalues[3];
		i[1] = fvalues[4];
		i[1] = orop(i,2);
		i[0] = orop(fvalues,3);
		i[2] = fvalues[5];

		value = nandop(i,3);
	}else if(gtype[gateid] == OAI322){
		i = new int[3];
		i[0] = fvalues[5];
		i[1] = fvalues[6];
		i[2] = orop(i,2);
		i[0] = fvalues[3];
		i[1] = fvalues[4];
		i[1] = orop(i,2);
		i[0] = orop(fvalues,3);

		value = nandop(i,3);
	}else if(gtype[gateid] == OAI33){
		i = new int[3];
		i[0] = fvalues[3];
		i[1] = fvalues[4];
		i[2] = fvalues[5];
		i[1] = orop(i,3);
		i[0] = orop(fvalues,3);

		value = nandop(i,2);
	}else if(gtype[gateid] == OAI43){
		i = new int[3];
		i[0] = fvalues[4];
		i[1] = fvalues[5];
		i[2] = fvalues[6];
		i[1] = orop(i,3);
		i[0] = orop(fvalues,4);

		value = nandop(i,2);
	}else if(gtype[gateid] == OAI332){
		i = new int[3];
		i[0] = fvalues[3];
		i[1] = fvalues[4];
		i[2] = fvalues[5];
		i[2] = orop(i,3);
		i[0] = fvalues[6];
		i[1] = fvalues[7];
		i[1] = orop(i,2);
		i[0] = orop(fvalues,3);

		value = nandop(i,3);
	}else if(gtype[gateid] == OAI44){
		i = new int[4];
		i[0] = fvalues[4];
		i[1] = fvalues[5];
		i[2] = fvalues[6];
		i[3] = fvalues[7];
		i[1] = orop(i,4);
		i[0] = orop(fvalues,4);

		value = nandop(i,2);
	}

delete [] i;
return value;

}

/*****AO****/
int circuit::aoop(int fvalues[],int gateid){
	int *i;
	int value;

	if (gtype[gateid] == AO21){
		i = new int[2];
        i[0] = andop(fvalues,2);
        i[1] = fvalues[2];


        value = orop(i,2);

    }else if(gtype[gateid] == AO22){
		i = new int[2];
		i[0] = fvalues[2];
		i[1] = fvalues[3];
		i[0] = andop(i,2);
		i[1] = andop(fvalues,2);


    	value = orop(i,2);

	}else if(gtype[gateid] == AO221){
		i = new int[3];
		i[0] = fvalues[2];
		i[1] = fvalues[3];
		i[0] = andop(i,2);
		i[1] = andop(fvalues,2);
		i[2] = fvalues[4];


		value = orop(i,3);
	}else if(gtype[gateid] == AO32){
		i= new int[2];
		i[0]=fvalues[3];
		i[1]=fvalues[4];
		i[0]=andop(i,2);
		i[1]=andop(fvalues,3);


		value = orop(i,2);
	}

delete [] i;
return value;

}

/*****AOI****/
int circuit::aoiop(int fvalues[],int gateid){
	int *i;
	int value;

	if (gtype[gateid] == AOI21){
		i = new int[2];
        i[0] = andop(fvalues,2);
        i[1] = fvalues[2];

        value = norop(i,2);

    }else if(gtype[gateid] == AOI22){
		i = new int[2];
		i[0] = fvalues[2];
		i[1] = fvalues[3];
		i[0] = andop(i,2);
		i[1] = andop(fvalues,2);


		value = norop(i,2);
	}else if(gtype[gateid] == AOI221){
		i = new int[3];
		i[0] = fvalues[2];
		i[1] = fvalues[3];
		i[0] = andop(i,2);
		i[1] = andop(fvalues,2);
        i[2] = fvalues[4];


		value = norop(i,3);

	}else if(gtype[gateid] == AOI222){
		i = new int[3];
		i[0] = fvalues[4];
		i[1] = fvalues[5];
		i[2] = andop(i,2);
		i[0] = fvalues[2];
		i[1] = fvalues[3];
		i[1] = andop(i,2);
		i[0] = andop(fvalues,2);

		value = norop(i,3);

	}else if(gtype[gateid] == AOI32){
		i = new int[2];
		i[0] = fvalues[3];
		i[1] = fvalues[4];
		i[0] = andop(i,2);
		i[1] = andop(fvalues,3);


		value = norop(i,2);

	}else if(gtype[gateid] == AOI321){
		i = new int[3];
		i[0] = fvalues[3];
		i[1] = fvalues[4];
		i[0] = andop(i,2);
		i[1] = andop(fvalues,3);

        i[2] = fvalues[5];

		value = norop(i,3);

	}else if(gtype[gateid] == AOI322){
		i = new int[3];
		i[0] = fvalues[5];
		i[1] = fvalues[6];
		i[2] = andop(i,2);
		i[0] = fvalues[3];
		i[1] = fvalues[4];
		i[1] = andop(i,2);
		i[0] = andop(fvalues,3);

		value = norop(i,3);
	}else if(gtype[gateid] == AOI33){
		i = new int[3];

		i[0] = fvalues[3];
		i[1] = fvalues[4];
		i[2] = fvalues[5];
		i[1] = andop(i,3);
		i[0] = andop(fvalues,3);

		value = norop(i,2);
	}else if(gtype[gateid] == AOI43){
		i = new int[4];

		i[0] = fvalues[4];
		i[1] = fvalues[5];
		i[2] = fvalues[6];
		i[1] = andop(i,3);
		i[0] = andop(fvalues,4);

		value = norop(i,2);
	}

delete [] i;
return value;

}

/*****OR****/
int circuit::orop(int fvalues[],int count){
	int i;
	i=norop(fvalues,count);
	return notop(i);
}

/*****NOR****/
int circuit::norop(int fvalues[],int count){
	int i,xcount=0;
	for(i=0; i < count; i++){
		if(fvalues[i] == 1){
			return 0;
		}else if(fvalues[i] == 2){
			xcount++;
		}
	}
	if(xcount > 0)
		return 2;
	else
		return 1;
}

/*****NOR02_ii****/
int circuit::norii_op(int fvalues[],int count){
	fvalues[1]=notop(fvalues[1]);
	return norop(fvalues,count);

}

/*****XOR****/
int circuit::xorop(int fvalues[],int count){
	int i;
	i=xnorop(fvalues,count);
	return notop(i);

}

/*****XNOR****/
int circuit::xnorop(int fvalues[],int count){
	int i;
	for(i=0; i < count-1; i++){
		if(fvalues[i] == 2 || fvalues[i+1] == 2){
			return 2;
		}else if(fvalues[i] != fvalues[i+1]){
			return 0;
		}
	}
	return 1;
}

/*****NOT****/
int circuit::notop(int fvalues){

	if(fvalues == 1){
		return 0;
	}else if(fvalues == 0){
		return 1;
	}

	return 2;
}

/*****DFF & DFFR****/
int circuit:: dffop(int fvalues[],int gateid){


	if(gtype[gateid] == DFFR){
		if(fvalues[2] == 1)
	    return 0;
	}

		/*if(gtype[gateid + 1] == QBAR)
	  	gnew[gateid + 1] = notop(fvalues[0]);*/
	if((clkevent == 1) && (fvalues[1] == 1)){
	    //printf("gateid %d gold[gateid] %d clkevent %d fvalues %d \n",gateid,gold[gateid],clkevent,fvalues[0]);
	    return fvalues[0];                                         /***** if its a clkevent and clk is 1 then propagate input to output *****/
	}else{
	    return gold[gateid];                                       /**** no change in output ****/
	}
}

int circuit:: latchop(int fvalues[],int gateid){


	if(gtype[gateid] == LATCHR){
		if(fvalues[2] == 1)
	    return 0;
	}else if(gtype[gateid] == LATCHS){
		if(fvalues[2] == 0)
	    return 1;
	}else if(gtype[gateid] == LATCHS_NI){
		if(fvalues[2] == 1)
	    return 1;
	}

    // printf("gateid %d gold[gateid] %d clk %d fvalues %d \n",gateid,gold[gateid],fvalues[1],fvalues[0]);
	if(fvalues[1] == 1){                                            /***** if clock is one *****/
	   // printf("gateid %d gold[gateid] %d fvalues %d \n",gateid,gold[gateid],fvalues[0]);
	    if(gtype[gateid] == LATCH)
	    return fvalues[0];                                         /***** if latch return Q output ****/
	    else
	    return notop(fvalues[0]);                                  /***** else return QBAR output ****/
	}else{
	    return gold[gateid];                                       /**** no change in output ****/
	}
}


