
#include "powerclass.h"

/**** For Simple gates (nand,or,nor etc..)*****/
void circuit::runscript(int g1,int fvalues[],int fancount,const char* type){

	int i;
	char cmdline[100],str[5];
	strcpy(cmdline,"sh ./scripts/run_");
	if(fancount <= 4)
	sprintf(str,"%d",fancount);
	else
	sprintf(str,"%d",4);                                   /* for fanins greater than 4 , do same as that of 4 inputs*/
	strcat(cmdline,str);
	strcat(cmdline,"s ");
	strcat(cmdline,techfile);
	strcat(cmdline,".mod ");
	sprintf(str,"%2.1f ",Vdd);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",L);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",Wn);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",Wp);
	strcat(cmdline,str);
	sprintf(str,"%d",gtype[g1]);
	strcat(cmdline,str);
	strcat(cmdline,"_0");
	sprintf(str,"%d ",fanin[g1]);
	strcat(cmdline,str);
	strcat(cmdline,type);

	for(i=0;i<fancount;i++){
		sprintf(str," %d",fvalues[i]);
		strcat(cmdline,str);
	}

	if(gtype[g1] != OUTPUT && gtype[g1] != QBAR && gtype[g1] != CLK){                        /*why this is happening ..find out later*/
    printf("cmdline %s \n",cmdline);
	system(cmdline);
	}
	return;
}

/*** For complex gates (aoi,oai etc....) ****/
void circuit::runcmplx(int g1,int fvalues[]){

	int i;
	char cmdline[100],str[5];
	strcpy(cmdline,"sh ./scripts/run_cmplx");
	sprintf(str,"%d ",fanin[g1]);
	strcat(cmdline,str);
	strcat(cmdline,techfile);
	strcat(cmdline,".mod ");
	sprintf(str,"%2.1f ",Vdd);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",L);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",Wn);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",Wp);
	strcat(cmdline,str);
	sprintf(str,"%d ",gtype[g1]);
	strcat(cmdline,str);
	sprintf(str,"%d ",fanin[g1]);
	strcat(cmdline,str);

	for(i=0;i<fanin[g1];i++){
		sprintf(str," %d",fvalues[i]);
		strcat(cmdline,str);
	}
	printf("cmdline %s \n",cmdline);
	system(cmdline);
	return;
}

/**** For DFF/DFFR *****/
void circuit::runff(int g1,int fvalues[]){

	int i;
	char cmdline[100],str[5];
	strcpy(cmdline,"sh ./scripts/run_dff ");
	strcat(cmdline,techfile);
	strcat(cmdline,".mod ");
	sprintf(str,"%2.1f ",Vdd);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",lambda);
	strcat(cmdline,str);
	sprintf(str,"%d",gtype[g1]);
	strcat(cmdline,str);
	strcat(cmdline,"_0");
	sprintf(str,"%d ",fanin[g1]);
	strcat(cmdline,str);
	sprintf(str,"%2.1f ",tr);
	strcat(cmdline,str);
	sprintf(str,"%d",clkperiod);
	strcat(cmdline,str);

	for(i=0;i<fanin[g1];i++){
		sprintf(str," %d",fvalues[i]);
		strcat(cmdline,str);
	}
	printf("cmdline %s \n",cmdline);
	system(cmdline);
	return;
}

void circuit::runlatch(int g1,int fvalues[]){

	int i;
	char cmdline[100],str[5];
	strcpy(cmdline,"sh ./scripts/run_latch ");
	strcat(cmdline,techfile);
	strcat(cmdline,".mod ");
	sprintf(str,"%2.1f ",Vdd);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",lambda);
	strcat(cmdline,str);
	sprintf(str,"%d",gtype[g1]);
	strcat(cmdline,str);
	strcat(cmdline,"_0");
	sprintf(str,"%d ",fanin[g1]);
	strcat(cmdline,str);

	for(i=0;i<fanin[g1];i++){
		sprintf(str," %d",fvalues[i]);
		strcat(cmdline,str);
	}
	printf("cmdline %s \n",cmdline);
	system(cmdline);
	return;
}

void circuit::runstand(int input,int flag1, int flag2){                          /**** running a standard invertor model with an output load *****/
                                                         /**** running model to accumulate technology parameters for short circuit model *****/
	int i;
	char cmdline[100],str[5];
	strcpy(cmdline,"sh ./scripts/run_stand ");
	strcat(cmdline,techfile);
	strcat(cmdline,".mod ");
	sprintf(str,"%2.1f ",Vdd);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",L);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",Wn);
	strcat(cmdline,str);
	sprintf(str,"%4.3f ",Wp);
	strcat(cmdline,str);
	sprintf(str,"%d ",input);
	strcat(cmdline,str);
	sprintf(str,"%d ",flag1);
	strcat(cmdline,str);
	sprintf(str,"%d ",flag2);
	strcat(cmdline,str);

	printf("cmdline %s \n",cmdline);
	system(cmdline);
	return;
}
