#include "powerclass.h"

/*** runstand : input parameters => input value, flag1, flag2
input value indicates which kind of input transition: rising or falling
flag1 indicates which kind of resistance(or Bn/Bp variation) : smaller transistor or bigger
flag2 indicates which kind of load: low cap load or high cap load ***/

void circuit::runstandmodel(){


getcellsize(0);
runstand(0,0,0);
runstand(1,0,0);
runstand(0,0,1);
runstand(1,0,1);
Wn=2*Wn,Wp=2*Wp;
runstand(0,1,0);
runstand(1,1,0);
}


void circuit::readtechlib(){

FILE *infile,*infile1,*infile2,*fp;
int i,j=0;
char fname[50],str[20];
float Vtn=0,Vtn1=0,Vtp=0,Vtp1=0,Vout=0,Vout1=0;
float t=0.5e-9;
float tr=0.8e-9;
float cap[6],eps[6],betan[6],betap[6];
//float e0,e1,e01,e11;

strcpy(fname,"models/cap/tech.lib");
infile=fopen(fname,"r");

strcpy(fname,"models/cap/tech1.lib");
infile1=fopen(fname,"r");

strcpy(fname,"models/cap/tech2.lib");
infile2=fopen(fname,"r");

fp=infile;


for(i=0;i<=2;i++){

	j=i;
	if(i==1)
	fp=infile1;
	else if(i==2)
	fp=infile2;


	if(fp == NULL){
	  printf("tech file has not been created successfully\n");         /* if tech.lib doesnt exist creation error */
	  exit(-1);
	}

	  while(!feof(fp)){

		    fscanf(fp,"%s",&fname);

			if(!strcmp(fname,"0:capout="))
			fscanf(fp,"%f",&cap[j+i]);

			if(!strcmp(fname,"0:beta")){
			fscanf(fp,"%f",&betan[j+i]);
			fscanf(fp,"%f",&betap[j+i]);
			}

			if(!strcmp(fname,"0:vth")){
			fscanf(fp,"%f",&Vtn);
			fscanf(fp,"%f",&Vtp);
			}

			if(!strcmp(fname,"0:voltage")){
			fscanf(fp,"%f",&Vout);
			fscanf(fp,"%f",&Vout);
			}

			if(!strcmp(fname,"1:capout="))
			fscanf(fp,"%f",&cap[j+i+1]);

			if(!strcmp(fname,"1:beta")){
			fscanf(fp,"%f",&betan[j+i+1]);
			fscanf(fp,"%f",&betap[j+i+1]);
			}

			if(!strcmp(fname,"1:vth")){
			fscanf(fp,"%f",&Vtn1);
			fscanf(fp,"%f",&Vtp1);
			}

			if(!strcmp(fname,"1:voltage")){
			fscanf(fp,"%f",&Vout1);
			fscanf(fp,"%f",&Vout1);
			}

		}

/**** formulae got by solving voltage equation using matlab *****/

eps[j+i]=log(6*pow(tr,3)*((Vout/Vdd) - 1)/(pow(-t,3) + 3*pow(t,2)*(Vtn/Vdd)*tr-3*t*pow((Vtn/Vdd),2)*pow(tr,2)+pow((Vtn/Vdd),3)*pow(tr,3)))/log(Vdd*betan[j+i]*tr/cap[j+i]);

//printf("index %d eps %f betan %f betap %f cap %f \n",j+i,eps[j+i],betan[j+i]/1e-6,betap[j+i]/1e-6,cap[j+i]/1e-15);


//log(-6*Vout*tr^3/(-t^3+3*t^2*tr+3*t^2*p*tr-3*t*tr^2-6*t*p*tr^2-3*t*p^2*tr^2+tr^3+3*p*tr^3+3*p^2*tr^3+p^3*tr^3))/log(Vdd*betap*tr/cap)

//log(6*Vout*tr^3/(t^3+3*t^2*p*tr+3*t*p^2*tr^2+p^3*tr^3))/log(Vdd*betap*tr/cap)

//eps[j+i+1]=log(-6*(Vout1/Vdd)*pow(tr,3)/(pow(t,3)-3*pow(t,2)*tr-3*pow(t,2)*(Vtp1/Vdd)*tr+3*t*pow(tr,2)+6*t*(Vtp1/Vdd)*pow(tr,2)+3*t*pow((Vtp1/Vdd),2)*pow(tr,2)-pow(tr,3)-3*(Vtp1/Vdd)*pow(tr,3)-3*pow((Vtp1/Vdd),2)*pow(tr,3)-pow((Vtp1/Vdd),3)*pow(tr,3)))/log(Vdd*betap[j+i+1]*tr/cap1);

eps[j+i+1]=log(6*Vout1*pow(tr,3)/(pow(t,3)+3*pow(t,2)*(Vtp1/Vdd)*tr+3*t*pow((Vtp1/Vdd),2)*pow(tr,2)+pow((Vtp1/Vdd),3)*pow(tr,3)))/log(Vdd*betap[i+j+1]*tr/cap[i+j+1]);

//eps[j+i+1]=log(6*(Vout1/Vdd)*pow(tr,3)/(pow(-t,3)+3*pow(t,2)*tr+3*pow(t,2)*(Vtp1/Vdd)*tr-3*t*pow(tr,2)-6*t*(Vtp1/Vdd)*pow(tr,2)-3*t*pow((Vtp1/Vdd),2)*pow(tr,2)+pow(tr,3)+3*(Vtp1/Vdd)*pow(tr,3)+3*pow((Vtp1/Vdd),2)*pow(tr,3)+pow((Vtp1/Vdd),3)*pow(tr,3)))/log(Vdd*betap[j+i+1]*tr/cap[j+i+1]);

//eps1=log(6*pow(tr,3)*((Vout/Vdd) - 1)/(pow(-t,3) + 3*pow(t,2)*(Vtn/Vdd)*tr-3*t*pow((Vtn/Vdd),2)*pow(tr,2)+pow((Vtn/Vdd),3)*pow(tr,3)))/log(Vdd*betan*tr/cap);

//printf("index %d eps1 %f betan %f betap %f cap1 %f \n",j+i+1,eps[j+i+1],betan[j+i+1]/1e-6,betap[j+i+1]/1e-6,cap[j+i+1]/1e-15);

}

e0=(eps[0] - eps[2])/(betap[0] - betap[2]);
e1=eps[0] - e0*betap[0];

e01=(eps[1] - eps[3])/(betan[1] - betan[3]);
e11=eps[1] - e01*betan[1];


e1p=(eps[0] - eps[4])/(cap[0] - cap[4]);
e0p=((eps[0] - eps[2]) - e1p*(cap[0] - cap[2]))/(betap[0] - betap[2]);
e2p=eps[0]-e0p*betap[0]-e1p*cap[0];

//printf("e0p %f e1p %f e2p %f \n",e0p,e1p,e2p);

e1n=(eps[1] - eps[5])/(cap[1] - cap[5]);
e0n=((eps[1] - eps[3]) - e1n*(cap[1] - cap[3]))/(betan[1] - betan[3]);
e2n=eps[1]-e0n*betan[1]-e1n*cap[1];

//printf("e0n %f e1n %f e2n %f \n",e0n,e1n,e2n);


fclose(infile);
fclose(infile1);

}

float circuit::shortckt(int gateid, float cload,int t){

	int i,j,g,gevent;
	//float tp;
	float trr;
	//float tperiod=1e-9;
	//float VH=Vdd;
	//float VL=0;
	//float dV=VH - VL;
	//float cload;
	float Isc;
	float Ps;


		for(j=0;j<fanin[gateid];j++){
			g=faninlist[gateid][j];
			for(i=0;i<glistnum[t];i++){
				if(gateevent[t][i] == g)
                gevent=gateevent[t][i];
			}
		}

		if(gtype[gevent] == INPUT)
	    trr=1e-9;
		else if(gtype[gevent] == DFF || gtype[gevent] == DFFR)                         /**** time being fix : since short circuit not estimated for DFF/DFFR we need output rise/fall time: so setting to 0.1e-9****/
		trr=0.15e-9;
		else
		trr=trf[gevent];

	  // printf("gevent %d trr %f for gateid %d \n",g,trr/1e-9,gateid);


		if(gtype[gateid] == INV || gtype[gateid] == INV_2X || gtype[gateid] == INV_4X || gtype[gateid] == INV_8X || gtype[gateid] == INV_12X    )
			Isc=notsckt(gateid,gold[g],t,cload,trr);
		else if(gtype[gateid]== NAND)
		    Isc=nandsckt(gateid,gold[g],t,cload,trr);
		else if(gtype[gateid]== AND)
		    Isc=andsckt(gateid,gold[g],t,cload,trr);
		else if(gtype[gateid] == NOR)
		    Isc=norsckt(gateid,gold[g],t,cload,trr);
		else if(gtype[gateid] == OR)
		    Isc=orsckt(gateid,gold[g],t,cload,trr);
		else if(gtype[gateid] == XOR)
		    Isc=xorsckt(gateid,gold[g],t,cload,trr);
		else if(gtype[gateid] == AO22)
		    Isc=ao22sckt(gateid,gold[g],t,cload,trr);
		else if(gtype[gateid] == XNOR)
		    Isc=xnorsckt(gateid,gold[g],t,cload,trr);
		else if(gtype[gateid] == BUFF)
		    Isc=bufsckt(gateid,gold[g],t,cload,trr);
		else if(gtype[gateid] == MUX || gtype[gateid] == MUX_NI)
		    Isc=muxsckt(gateid,gold[g],t,cload,trr);
		else{
			 printf("Gate type not understood %d\n",gateid);
			exit(-1);
		}


		/*	  if(gold[gateid] == 0 && gnew[gateid] == 1){
				 if(gtype[gevent] == INPUT){
				  trr=tr*1e-9;
				  }else{
				  cload=getcload(gevent);
                  trr=getRon('n')*cload*(log((VH - 2*getVthn() + 0.9*dV)/(VH - 0.9*dV))+2*(getVthn() - 0.01*dV)/(VH - getVthn()));
			      }
                 getcellsize(gateid);
                 Ps = Ipavg(CLOAD,trr,'n')*VH*trr;
			  }else{

				  if(gtype[gevent] == INPUT){
				  trr=tr*1e-9;
				  }else{

				   cload=getcload(gevent);
                   trr=getRon('p')*cload*(log((VH + 0.01*dV + 2*getVthp())/(VH - 0.01*dV))+2*(getVthp() + 0.9*dV)/(VH + getVthp()));
			      }

                 getcellsize(gateid);
                 Ps = Ipavg(CLOAD,trr,'p')*VH*trr;

			  }*/



     Ps = Isc*Vdd*trr;

     //printf("gateid %d Isc %f Ps %f trr %f\n",gateid,Isc/1e-6,Ps/1e-15,trr/1e-9);

	 return Ps;
}


/*float circuit::getUeffn(){
    float U0,UA,UB,UC;
	float VTH=getVthn();

    if(T != Tnom){
			U0=U0p*pow((T/Tnom),UTEp);
			UA=UAn + UA1n*((T/Tnom) - 1);
	        UB=UBn + UB1n*((T/Tnom) - 1);
	        UC=UCn + UC1n*((T/Tnom) - 1);
	}else{
			U0=U0n;
			UA=UAn;
			UB=UBn;
	        UC=UCn;
	}

	float Ueffn=(U0)/(1 + (UA+ UC*Vbsx)*((Vgs - VTH + 2*VTH)/TOX) + UB*pow(((Vgs - VTH + 2*VTH)/TOX),2));

	return Ueffn;
}

float circuit::getUeffp(){
    float U0,UA,UB,UC;
    float VTH=getVthp();

    if(T != Tnom){
		U0=U0p*pow((T/Tnom),UTEp);
		UA=UAp + UA1p*((T/Tnom) - 1);
        UB=UBp + UB1p*((T/Tnom) - 1);
        UC=UCp + UC1p*((T/Tnom) - 1);
	}else{
		U0=U0p;
		UA=UAp;
		UB=UBp;
        UC=UCp;
	}
	float Ueffp=(U0)/(1 + (UA+ UC*Vbsx)*((Vgs + VTH  - 2*VTH)/TOX) + UB*pow(((Vgs + VTH - 2*VTH)/TOX),2));


	return Ueffp;
}

float circuit::getRon(char c){
	float B,Ron;
	float VH=Vdd;
	if(c == 'n'){
		B=getUeffn()*Cox*Weffn/Leffn;
		Ron=1/(B*(VH - getVthn())) + (RDSWn*1e-6*(1 + PRWGn*(Vgs - getVthn()) + PRWBn*1e-6*(sqrt(PHIn - Vbsx) - sqrt(PHIn))))/pow(Weffn,WRn);
	}else{
		B=getUeffp()*Cox*Weffp/Leffp;
		Ron=1/(B*(VH + getVthp())) + (RDSWp*1e-6*(1 + PRWGp*(Vgs - getVthp()) + PRWBp*1e-6*(sqrt(PHIp - Vbsx) - sqrt(PHIp))))/pow(Weffp,WRp);
	}


	return Ron;

}*/


float circuit::Ipavg(int gateid,int t,float cload,float t0){
	float k,x,Vo,Vo2,Ip1=0,Ip2=0;
	float n,p,epsn,epsp;
	char chk;
	float tt=0.01e-9;
	float Voo=0;
	int count=1;
	float Iptotal=0,Ip11=0,Ip22=0;
	float Ipavg;
	float ta=0,tb=0;


	//readbeta(gateid,input);

	if(gold[gateid] == 0 && gnew[t][gateid] == 1)
	chk='n';
	else
	chk='p';

	n=Vtn/Vdd;
	p=Vtp/Vdd;

	//printf("n %f p %f \n",n,p);


	//printf("Bn %f \n Bp %f \n",Bn/1e-6,Bp/1e-6);



	epsn=Bn*e0n+e1n*cload+e2n;
	epsp=Bp*e0p+e1p*cload+e2p;

    //printf("cload %f \n",cload/1e-15);


	if(chk == 'p')
	k=(pow(((Vdd*Bn*t0)/(cload)),epsp))/6;
	else
	k=(pow(((Vdd*Bp*t0)/(cload)),epsn))/6;




	float c= 1 - n + p;
	float k1=1/k;
	float k2= c/k;



	float a = 0.5*(k2 + sqrt((k2*k2) + (4*k1*k1*k1)/27));



	float z=pow(a,0.33333);

	float y= z - (k1/(3*z));


	if(chk == 'p')
	x=y+n;
	else
	x=y-p;


	float t2=x*t0;

	//printf("t2 %f\n",t2/1e-9);

    if(chk == 'p'){
	Vo = 1 - (k*pow(((t2/t0) - n),3));
    Vo2=(t2/t0) - p;

    //printf("Vout %f Vout1 %f \n",Vo*2.5,Vo2*2.5);

	Ip1 = Vdd*Vdd*Bp*(((t2/t0) - 1 - p)*(Vo - 1) - 0.5*pow((Vo - 1),2));
    Ip2 = 0.5*Vdd*Vdd*Bp*pow(((t2/t0) - 1 - p),2);

    //printf("Ip1 %f Ip2 %f \n",Ip1/1e-6,Ip2/1e-6);

    Iptotal=Iptotal+Ip1;


    while(tt < t0){
		//if(tt > (n*t0) && tt < ((1+p)*t0)){
		if(tt > (n*1e-9)){
		Voo=1 - (k*pow(((tt/t0) - n),3));
		//printf("falling tt %f Vout %f Vin %f\n",tt/1e-9,Voo*Vdd,(tt/t0)*Vdd);

        if(tt <= t2){
		Ip11=Vdd*Vdd*Bp*(((tt/t0) - 1 - p)*(Voo - 1) - 0.5*pow((Voo - 1),2));
		//printf(" Ip1 %f\n ",(Ip11)/1e-6);
		//if(Ip11 <= Ip1)
		Iptotal=Iptotal+Ip11;

	    }else{
        Ip22=0.5*Vdd*Vdd*Bp*pow(((tt/t0) - 1 - p),2);
		//printf(" Ip2 %f\n ",(Ip22)/1e-6);
		//if(Ip22 <= Ip2)
		Iptotal=Iptotal+Ip22;
		}
		count++;
		}
    tt=tt+0.01e-9;
    }



    ta=pow(((1 - (0.01))/k),0.33333)*t0 + n*t0;                                 /***** using voltage equation to find rise and fall times ****/
    tb=pow(((1 - (0.9))/k),0.33333)*t0 + n*t0;                                 /***** replacing 0.01V and 0.9V in normalized equation *****/

    trf[gateid]=ta - tb;

    if(trf[gateid] >= 1e-9)                                                    /****** for high load capacitances , voltage fall or rise is very slow ****/
    trf[gateid]=0.8e-9;




    }else{



    Vo = k*pow(((t2/t0) + p),3);

	//Vo = k*pow(((1 - (t2/t0)) - 1 - p),3);

    //Vo2=1 - (t2/t0) - n;
    Vo2=1 - (t2/t0) - n;


    //printf("Bn %f t2 %f t0 %f n %f Vo %f \n",Bn/1e-6,t2/1e-9,t0/1e-9,n,Vo);

    Ip1 = Vdd*Vdd*Bn*((1 - t2/t0 - n)*(Vo) - 0.5*pow((Vo),2));                      /***** Vin in case of falling transition is 1 - t2/t0 ****/
	Ip2 = 0.5*Vdd*Vdd*Bn*pow(((1 - t2/t0) - n),2);

	//printf("Ip1 %f Ip2 %f \n",Ip1/1e-6,Ip2/1e-6);


Iptotal=Iptotal+Ip1;

	 while(tt < t0){
			//if(tt > (-p*t0) && tt < (1-n)*t0){
			if(tt > (-p*1e-9)){
			Voo=k*pow(((tt/t0) + p),3);
    		//printf("rising tt %f Vout %f Vin %f\n",tt/1e-9,Voo*Vdd,(1-tt/t0)*Vdd);


	        if(tt <= t2){
			Ip11= Vdd*Vdd*Bn*((1 - tt/t0 - n)*(Voo) - 0.5*pow((Voo),2));
	//		printf(" Ip1 %f\n ",(Ip11)/1e-6);
			//if(Ip11 <= Ip1)
			Iptotal=Iptotal+Ip11;

		    }else{
	        Ip22=0.5*Vdd*Vdd*Bn*pow(((1 - tt/t0) - n),2);
	//		printf(" Ip2 %f\n ",(Ip22)/1e-6);
			//if(Ip22 <= Ip2)
			Iptotal=Iptotal+Ip22;
			}
			count++;
			}
	    tt=tt+0.01e-9;
	    }

	ta=pow((0.01/k),0.33333)*t0 - p*t0;
    tb=pow((0.9/k),0.33333)*t0 - p*t0;


    trf[gateid]=tb - ta;

    if(trf[gateid] >= 1e-9)                                                    /****** for high load capacitances , voltage fall or rise is very slow ****/
	trf[gateid]=0.8e-9;


	}

   // printf("gateid %d trf %f \n",gateid,trf[gateid]/1e-9);

	Ipavg=Iptotal/(count+1);

	//printf("Ipavg %f gateid %d \n",Ipavg/1e-6,gateid);

	return Ipavg;
}


float circuit::notsckt( int gateid, int input ,int t,float cload,float trr){
	float Isc;
	readbeta(0,input);
	Isc=Ipavg(gateid,t,cload,trr);
	return Isc;
}

float circuit::nandsckt(int gateid, int input ,int t,float cload,float trr){

	float Isc;
	readbeta(gateid,input);
	Bn=Bn/fanin[gateid],Bp=Bp*fanin[gateid];
	Isc=Ipavg(gateid,t,cload,trr);
	return Isc;

}

float circuit::andsckt(int gateid, int input ,int t,float cload,float trr){

	float Isc=0;
	float tint;

	tint=0.2e-9;
	Isc=Isc + nandsckt(gateid,input,t,cload,trr);
	Isc=Isc + notsckt(gateid,notop(input),t,cload,tint);                                 /**** giving gateid 0 for standard invertor sizing*****/
																					/**** giving tfall/trise of 0.2e-9 as its small within the gate***/
	return Isc;

}

float circuit::orsckt(int gateid, int input ,int t,float cload,float trr){

	float Isc=0;
	float tint;

	tint=0.2e-9;
	Isc=Isc + norsckt(gateid,input,t,cload,trr);
	Isc=Isc + notsckt(gateid,notop(input),t,cload,tint);                                 /**** giving gateid 0 for standard invertor sizing*****/
																					/**** giving tfall/trise of 0.2e-9 as its small within the gate***/
	return Isc;

}


float circuit::norsckt(int gateid, int input ,int t,float cload,float trr){

	float Isc;
	readbeta(gateid,input);
	Bn=Bn*fanin[gateid],Bp=Bp/fanin[gateid];
	Isc=Ipavg(gateid,t,cload,trr);
	return Isc;

}

float circuit::xorsckt(int gateid, int input ,int t,float cload,float trr){

	float Isc=0;

	Isc=Isc + 2*nandsckt(gateid,input,t,cload,trr);           /***** xor equivalent to 4 nand gates connected ****/
	//Isc=Isc + nandsckt(gateid,notop(input),t,cload,trr);  /***** averaging over 4 nand gates ****/

	//Isc=Isc/2;

	return Isc;

}

float circuit::xnorsckt(int gateid, int input ,int t,float cload,float trr){

	float Isc=0;
	float tint;

	tint=0.2e-9;

	Isc=Isc + 2*nandsckt(gateid,input,t,cload,trr);           /***** xor equivalent to 4 nand gates connected ****/
	Isc=Isc - notsckt(gateid,notop(input),t,cload,tint);          /**** xnor is xor without invertor***/

	return Isc;

}

float circuit::ao22sckt(int gateid, int input ,int t,float cload,float trr){
	float Isc=0;
	float tint;
	tint=0.2e-9;

	Isc=Isc + 2*andsckt(gateid,input,t,cload,trr);
	Isc=Isc + orsckt(gateid,input,t,cload,tint);

    return Isc;
}

float circuit::muxsckt(int gateid, int input ,int t,float cload,float trr){
	float Isc=0;
	float tint;
	tint=0.2e-9;
    Isc=Isc +  notsckt(gateid,input,t,cload,trr);
    return Isc;
}

float circuit::bufsckt(int gateid, int input ,int t,float cload,float trr){
	float Isc=0;
	float tint;
	tint=0.2e-9;

	Isc=Isc + notsckt(gateid,input,t,cload,trr);
	Isc=Isc + notsckt(gateid,notop(input),t,cload,tint);

    return Isc;
}


void circuit::readbeta(int gateid,int input){
FILE *infile2;
int i;
char fname[40],str1[50],str[2],str2[50];

sprintf(str, "%d",gtype[gateid]);
strcpy(fname,"models/cap/");
strcat(fname,str);
strcat(fname,"_0");
sprintf(str, "%d",fanin[gateid]);
strcat(fname,str);
strcat(fname,".cap");
infile2=fopen(fname,"r");

sprintf(str,"%d",input);
strcpy(str1,str);
strcpy(str2,str);


strcat(str1,":vth");
strcat(str2,":beta");


if(infile2 == NULL){
printf("Error: cap file cannot be found for beta,vth reading\n");
exit(-1);

}else{
	   while(!feof(infile2)){
		   fscanf(infile2,"%s",&fname);
			if(!strcmp(fname,str1)){
				fscanf(infile2,"%f",&Vtn);
				fscanf(infile2,"%f",&Vtp);
			}
			if(!strcmp(fname,str2)){
				fscanf(infile2,"%f",&Bn);
				fscanf(infile2,"%f",&Bp);
			}
		}
}
fclose(infile2);
}