#include "powerclass.h"

void circuit::simulation(char *cktname){

FILE *infile1,*infile;
char fname2[40];
clock_t start,end;
double timediff;
int m=0,n=0;
int i,j,k,t,t1,t2;
int logevents=0,events=0;
int leaktime;
float dynpower,totalleakage;
float logicpower;
int analysisperiod=0;
int testcount=0;
float totleakenergy=0.0,dynenergy=0.0;
float logicenergy=0.0,logenergy;
float minleakage=0,maxleakage=0,dynmaxim=0,dynminim=0,leakenergy;
float logicmin=0,logicmax=0,glitchmin=0,glitchmax=0,maxPs=0;
int maxvec = 1,minvec = 1 ,dynmin = 2,dynmax= 2;
int logmin=2,logmax=2,gmin=2,gmax=2;
int maxtime=0;
int maxtimecount=0;
int totevents=0,totlogevents=0,maxglitch,maxglitchvec=1,logeventchk=0,eventchk=0;
Ps=0.0;
float totenergy=0.0,maxtot;
float CLOAD=0.0;
int errorflag,errorcnt=0,ffcheck;
int gateid,gtid;
int badevent;
int worstcasedelay=0;
float clkpower=0;
int totclktick=0;
float ffcap=0;

start=clock();

strcpy(fname2,cktname);
strcat(fname2, ".vec");
infile1=fopen(fname2,"r");
if(infile1 == NULL){
printf("vector file cannot be found\n");
exit(-1);
}


strcpy(fname2, "models/cap/tech.lib");
infile=fopen(fname2,"r");
if(infile == NULL){
	printf("Tech libraries cannot be found. Creating....\n");
	runstandmodel();
}

/**** Creating technology parameters for short circuit evaluation ****/
readtechlib();



while(!feof(infile1)){

time=0;

if(isSeq == 1){
clktick=0;
//clkvalue=0;
clkevent=0;
//gnew[time][clkid]=0;
gold[clkid]=0;
}

	for(i=1;i<=ipcount;i++){
		if(gtype[i] != CLK){
			fscanf(infile1,"%d",&fid);
			gnew[time][i]=fid;


		   if(gnew[time][i] != gold[i]){
		    	eventlist[time][listnum[time]]=i;
		    	listnum[time]++;
		    	gevent[i]++;
		   }
   		}
   }


	logenergy=0;

	logevents=0;

 leakenergy=0;
 energy=0;
 events=0;
 Psini=0;
 errorflag=0;
 zerodelay=0;

 for(i=1;i<=linecount+1;i++){
 	if(gtype[i] != INPUT && gtype[i] != OUTPUT && gtype[i] != CLK && gtype[i] != QBAR){

 		  if(gtype[i] != DFF && gtype[i] != DFFR){

 			leakage[i]=leakagepow(i);
 		  }else{
 		    leakage[i]= dffleakage(i);
 		    cellpowerunit[i]=dffcellpower(i);
		  }
 	}
 }



 while (chkprocess(processed,time_wheel_size)){

	t=time%time_wheel_size;

	if(isSeq == 1){

		//gold[clkid]=gnew[t][clkid];
		gnew[t][clkid]=gold[clkid];

		if(time == (2*clktick + 1)*(clkperiod/2)){
		clktick++;                                          /* clktick defined as each positive edge of clock*/
        gnew[t][clkid]=1;                                   /* positive edge of clock*/
        clkevent=1;                                         /* clkevent for positive edge trigger */
		}else{
		clkevent=0;
		}

		if(time == (2*clktick)*(clkperiod/2)){
        gnew[t][clkid]=0;                                   /* negative edge of clock*/
		}

        if(gold[clkid] != gnew[t][clkid]){                   /* clock has event */
        eventlist[t][listnum[t]]=clkid;
        listnum[t]++;
		}
		//if(time >= (2*clktick)*(clkperiod/2) && time < (2*clktick + 1)*(clkperiod/2))
		//clkvalue=0;                                          /* clkvalue == 1 for positive edge of clock*/
		//else		//clkvalue=1;
	}

//printf("time %d clktick %d clkevent %d gold[clkid] %d gnew[clkid] %d clkid %d\n",time,clktick,clkevent,gold[clkid],gnew[t][clkid],clkid);

 for(j=0;j<listnum[t];j++){


      gateid=eventlist[t][j];


    if (glitchfilter(cktname,gateid,time)){

	    if(gold[gateid] != gnew[t][gateid]){



		       if(gtype[gateid] != INPUT && gtype[gateid] != OUTPUT && gtype[gateid] != CLK && gold[gateid] != 2){                         /* any event from X to logic value not considered..however the vice versa is so maxes out.*/
		       																															   /* clk events not considered as no clock tree structure has been formulated */
	  	   		   //if(gtype[fanoutlist[gateid][0]] != OUTPUT){

		   		  	  events=events + 1;
		   		  	  CLOAD=getcload(gateid);
		   		  	  gevent[gateid]++;

		   		  	  energy=energy+0.5*Vdd*Vdd*CLOAD;

		   		  	  //printf("gateid %d cload %f dyn energy %f\n",gateid,CLOAD/1E-15,(0.5*Vdd*Vdd*CLOAD)/1e-15);
					//  if(gtype[gateid] != DFF && gtype[gateid] != DFFR)                        /**** short circuit calculated via flip flop cell power ****/
	  	   		   //  Psini = Psini + shortckt(gateid,CLOAD,t);


	  	   		  //}
			  	}

		printf("time %d gateid %d gold %d gnew %d gevent %d\n",time,gateid,gold[gateid],gnew[t][gateid],gevent[gateid]);


		     gold[gateid]=gnew[t][gateid];

		 	 if(gtype[gateid] == INPUT)
		 	 gzero[gateid]=gold[gateid];

		}else{

			badevents[t][blistnum[t]]=gateid;                    /*bad event*/
			blistnum[t]++;
		}
  }

}



 for(j=0;j<listnum[t];j++){

     badevent=0;
     gateid=eventlist[t][j];

	   for(i=0;i<blistnum[t];i++){
		   if(gateid == badevents[t][i]){
		   badevent=1;
	   	   }
	   }



       if(badevent == 0){

		 for(i=0;i<fanout[gateid];i++){


			k=fanoutlist[gateid][i];

 			//if(gtype[k] == DFF || gtype[k] == DFFR){
		 	//	  if((time + delay(cktname,k)) <= (2*clktick + 1)*(clkperiod/2))
			// 			 t1 = ((2*clktick + 1)*(clkperiod/2))%time_wheel_size;             /*setting up clock event for flipflops*/
		    // }else{
			   	  t1=(time+delay(cktname,k))%time_wheel_size;
						// ffcheck++;
	    	// }




            if(gtype[k] != INPUT && gtype[k] != OUTPUT){
				gnew[t1][k] = evaluate(k);
						 //nextime[gateid]=time - 1;

					if(gtype[k + 1] == QBAR)               /* if k is dff and has a qbar out */
					gnew[t1][k+1]=notop(gnew[t1][k]);

			}


		 	if(gold[k] != gnew[t1][k]){

			if(scheduled[t1][k] != 1){
			eventlist[t1][listnum[t1]]=k;         /* for gates undergoing events*/
			listnum[t1]++;
			scheduled[t1][k]=1;

		    }

		    if(gtype[k+1] == QBAR){
				eventlist[t1][listnum[t1]]=k+1;         /* for qbar of dff undergoing events*/
				listnum[t1]++;

			}


            processed[t1]=0;

			/*if(gtype[k] == DFF || gtype[k] == DFFR)
                   t1=(time+delay(gateid))%time_wheel_size;                  /* restoring t1 for actual gate event*/



		    if(gscheduled[t1][gateid] != 1){
			  gateevent[t1][glistnum[t1]]=gateid;   /* for gates causing events*/
			  glistnum[t1]++;
			  gscheduled[t1][gateid]=1;
		    }

		  }else{

			  badevents[t1][blistnum[t1]]=k;                    /*bad event or not an event*/
		      blistnum[t1]++;

		  }
		}


	  }

}



for(i=0;i<time_wheel_size;i++){
   for(j=1;j< linecount + 1;j++){
 	scheduled[i][j]=0;
 	gscheduled[i][j]=0;
   }
}

processed[t]=1;
listnum[t]=0;
glistnum[t]=0;
blistnum[t]=0;


time=time + 1;



  for(m=0;m<listnum[time%time_wheel_size];m++){
  	   k=eventlist[time%time_wheel_size][m];
  	   if(gtype[k] != OUTPUT && gtype[k] != CLK && gtype[k] != QBAR){
			if(gtype[k] != DFF && gtype[k] != DFFR){
 	   			leakenergy=leakenergy+ leakage[k]*(time - nextime[k])*1e-9;
  	   			leakage[k]=leakagepow(k);
  	   			nextime[k]=time;
			}else{
				leakenergy=leakenergy+ leakage[k]*(time - nextime[k])*1e-9;
				ffcellpower=ffcellpower+cellpowerunit[k]*(time - nextime[k])*1e-9;
  	   		    leakage[k]=dffleakage(k);
  	   		    cellpowerunit[k]=dffcellpower(k);
  	   			nextime[k]=time;
			}
       }
  }

if(vecperiod != 0){

	if(time >= vecperiod){
	  printf("INFO: Simulation exceeds the vector period. Stopping simulation and counting transitions for the period. Please choose appropriate vector period for next simulation.\n");
	 // errorflag=1;
	  break;
	}
}else{

	if(time >= 10000){    /**** 10000 considered max time till we break loop ****/
		  printf("INFO: Simulation seems to be in feedback loop. Stopping simulation and counting transitions for the period. Check vector pair %d - %d \n", testcount,testcount+1);
		 // errorflag=1;
		  break;
	}
}


}

/**** END OF EVENT DRIVEN SIMULATION *****/

for(i=0;i<time_wheel_size;i++){
   for(j=0;j<listnum[i];j++){
   eventlist[i][j] = 0;
   gateevent[i][j]=0;
   }
   for(j=0;j<blistnum[i];j++){
	   badevents[i][j]=0;
   }
listnum[i]=0;
blistnum[i]=0;
glistnum[i]=0;
processed[i]=0;

}

testcount++;

for(gtid=ipcount+1;gtid<=linecount+1;gtid++){
	zerodelay=1;

	  if(gtype[gtid] != OUTPUT){

	           if(gzero[gtid] != gold[gtid]){
	     		  //if(gtype[fanoutlist[gtid][0]] != OUTPUT && gzero[gtid] !=2){
				  if(gzero[gtid] !=2){
					 logevents = logevents + 1;
					 logenergy=logenergy+0.5*Vdd*Vdd*getcload(gtid);
				  }

		    	gzero[gtid]=gold[gtid];
			   }

	  }
}



/*if(time > maxtime){
maxtimecount=0;
maxtime=time;
}*/

if(time > worstcasedelay)
	worstcasedelay=time;

time = clktick*clkperiod;                                /***** in case of seq analysis period given by total time clock is switching *****/
if(vecperiod == 0)
leaktime=time;
else
leaktime=vecperiod;

for(i=1;i<=linecount+1;i++){
	if(gtype[i] != INPUT && gtype[i] != OUTPUT && gtype[i] != CLK && gtype[i] != QBAR){

		  if(gtype[i] != DFF && gtype[i] != DFFR){

			if(leakage[i] == 0)                /***** if leakage is zero, check leakage libraries again *****/
			leakage[i]=leakagepow(i);          /***** error can happen if one gate input is X but the gate output is defined *****/

			leakenergy=leakenergy + leakage[i]*(leaktime - nextime[i])*1e-9;

			//printf("gateid %d leakenergy %f time %d \n", i,(leakage[i]*(leaktime - nextime[i])*1e-9)/(1e-19),leaktime - nextime[i]);
		   }else{
		    leakenergy=leakenergy+ leakage[i]*(leaktime - nextime[i])*1e-9;
			ffcellpower=ffcellpower+cellpowerunit[i]*(leaktime - nextime[i])*1e-9;
		   }
		nextime[i]=0;
	}
}


//printf("final leakenergy %f \n",leakenergy/1e-6);

if(testcount == 1)
maxglitch=events - logevents;


totevents=totevents+events;
totlogevents=totlogevents+logevents;


if((events - logevents) > maxglitch){
maxglitch=events - logevents;
logeventchk=logevents;
eventchk=events;
maxglitchvec=testcount;
}

totenergy=energy+leakenergy+Psini;

if(testcount == 2){
	minleakage=leakenergy/(leaktime*1e-9);
	maxleakage=leakenergy/(leaktime*1e-9);
	dynminim=energy/(leaktime*1e-9);
	dynmaxim=energy/(leaktime*1e-9);
	logicmin=logenergy/(leaktime*1e-9);
	logicmax=logenergy/(leaktime*1e-9);
	glitchmin=dynminim - logicmin;
	glitchmax=dynmaxim - logicmax;
	maxPs=Psini/(leaktime*1e-9);
	maxtot=totenergy/(leaktime*1e-9);
}
	if((leakenergy/(leaktime*1e-9)) > maxleakage){
	maxleakage=leakenergy/(leaktime*1e-9);
	maxvec=testcount;
    }

	if((leakenergy/(leaktime*1e-9)) < minleakage){
	minleakage=leakenergy/(leaktime*1e-9);
	minvec=testcount;
    }

    if((energy/(leaktime*1e-9)) < dynminim){
		dynminim=energy/(leaktime*1e-9);
		dynmin=testcount;
    }

    if((energy/(leaktime*1e-9)) > dynmaxim){
		dynmaxim=energy/(leaktime*1e-9);
		dynmax=testcount;
    }

    if((logenergy/(leaktime*1e-9)) < logicmin){
			logicmin=logenergy/(leaktime*1e-9);
			logmin=testcount;
	}

	if((logenergy/(leaktime*1e-9)) > logicmax){
			logicmax=logenergy/(leaktime*1e-9);
			logmax=testcount;
    }

    if(((energy/(leaktime*1e-9))-(logenergy/(leaktime*1e-9))) < glitchmin){
				glitchmin=((energy/(leaktime*1e-9))-(logenergy/(leaktime*1e-9)));
				gmin=testcount;
    }

    if(((energy/(leaktime*1e-9))-(logenergy/(leaktime*1e-9))) > glitchmax){
		        glitchmax=((energy/(leaktime*1e-9))-(logenergy/(leaktime*1e-9)));
				gmax=testcount;
    }

    if((Psini/(leaktime*1e-9)) > maxPs)
    maxPs=Psini/(leaktime*1e-9);

    if((totenergy/(leaktime*1e-9)) > maxtot)
    maxtot=totenergy/(leaktime*1e-9);


//if(time==maxtime)
//maxtimecount++;


dynenergy=dynenergy + energy;
logicenergy=logicenergy+logenergy;

totleakenergy=totleakenergy + leakenergy;
Ps= Ps + Psini;

printf("\n vector completed %d\n",testcount);

/*for(i=1;i<=linecount+1;i++){
	if(gtype[i] == OUTPUT)
	printf("gateid %d gold %d \n",i,gold[faninlist[i][0]]);
}*/


//}
analysisperiod=analysisperiod+time;
totclktick=totclktick+clktick;

}


if(vecperiod != 0){
//if(maxtime > (vecperiod)){
//    analysisperiod=(vecperiod)*(testcount-errorcnt-maxtimecount) + maxtime*maxtimecount;
//}else{
//    analysisperiod = (vecperiod)*(testcount-errorcnt);
    analysisperiod = (vecperiod)*(testcount);
//}

}

if(isSeq == 1){
ffcap=getcload(clkid);
clkpower=(2*totclktick*0.5*Vdd*Vdd*ffcap)/(analysisperiod*1.0e-9);
}


/*for(i=1;i<=linecount+1;i++){
	if(gtype[i] != INPUT && gtype[i] != OUTPUT)
	printf("gateid %d gold %d \n",i,gold[i]);
}*/



dynpower = (dynenergy/(analysisperiod*1.0e-9));
logicpower= (logicenergy/(analysisperiod*1.0e-9));
totalleakage=(totleakenergy/(analysisperiod*1.0e-9));
ffcellpower=(ffcellpower/(analysisperiod*1.0e-9));
Ps=(Ps/(analysisperiod*1.0e-9));
printf("Number of clock ticks %d \n",totclktick);
printf("max glitches %d caused by vector pair (%d,%d). logic events for this pair is %d and events %d\n",maxglitch,maxglitchvec -1 ,maxglitchvec,logeventchk,eventchk);
printf("maxtime %d maxtimecount %d\n",maxtime,maxtimecount);
printf("worst case delay %d \n",worstcasedelay);
printf("total analysis period in nano secs %d\n",analysisperiod);
printf("number of gates %d \n",gatecount);
printf("the number of events/node transitions %d logic events %d \n",totevents,totlogevents);
printf("average short circuit power in micro Watts: %f \n",Ps/1.0e-6);
printf("average leakage power consumption in pico Watts: %f\n",totalleakage/1.0e-12);
printf("average dynamic power consumption in micro Watts : %f\n",dynpower/1e-6);
printf("average logic power consumption in micro Watts : %f\n",logicpower/1e-6);
printf("average glitch power consumption in micro Watts : %f\n",(dynpower-logicpower)/1e-6);
if(isSeq == 1){
printf("average flip flop cell power in micro Watts : %f\n",ffcellpower/(1e-6));
printf("average clock power in micro Watts : %f\n",clkpower/(1e-6));
}
printf("total average power consumption %f \n",(dynpower + totalleakage + Ps)/1e-6);
printf("minimum leakage %f and vector causing %d \n",minleakage/1.0e-12,minvec);
printf("maximum leakage %f and vector causing %d \n",maxleakage/1.0e-12,maxvec);
printf("minimum dynamic power %f and vector pair causing (%d,%d) \n",dynminim/1.0e-6,dynmin-1,dynmin);
printf("maximum dynamic power %f and vector pair causing (%d,%d) \n",dynmaxim/1.0e-6,dynmax-1,dynmax);
printf("minimum logic power %f and vector pair causing (%d,%d) \n",logicmin/1.0e-6,logmin-1,logmin);
printf("maximum logic power %f and vector pair causing (%d,%d) \n",logicmax/1.0e-6,logmax-1,logmax);
printf("minimum glitch power %f and vector pair causing (%d,%d) \n",glitchmin/1.0e-6,gmin-1,gmin);
printf("maximum glitch power %f and vector pair causing (%d,%d) \n",glitchmax/1.0e-6,gmax-1,gmax);
printf("maximum Ps %f \n max total power %f\n",maxPs/1e-12,maxtot/1e-6);

fclose(infile1);
end=clock();
timediff=((long double)(end-start))/CLOCKS_PER_SEC;
printf("Execution time : %.21f \n",timediff);
}
